:userdoc.
:title.Version Changes

.********************************************************
:h1 res=1001 global.Version Changes, Bug Fixes
:p.
The following changes have been made since the first version of EULER
for OS/2.
:ul compact.
:li. Vertical page adjustment on print has been corrected.
:li. "redim" has been installed in UTIL.E.
:li. "getvector" returns the correct number of read items.
:li. Font profiling works now.
:li. A tiny bug in "xgrid" and "ygrid" removed.
:li. The "save commands" dialog was renamed and crashes no longer if
cancelled.
:li. A scroll bug with small fonts caused understokes to vanish. Removed.
:li. Help buttons inserted into settings dialogs.
:li. Meta files use the correct graphics font.
:li. Vertical scroll is now automatic on edit.
:li. Print dialog allows color switching for text, lines and markers.
:li. Prints can now be clipped to the window size.
:li. A tiny bug in the print routine caused titles to disappear. Removed.
:li. Marked text was not visually unmarked upon text output.
:li. A small bug in the automatic vertical scrolling removed.
:li. Crash with large plots removed.
:li. Euler now uses two threads. One is for the computation and graphics
output, the other for window messages.
:li. I tried to introduce vertical axis labels. But it didnt work. At 
least it is possible, to draw vertical text now from to to bottom with
vertical characters.
:li. Finally got clipboard bitmap copy to work.
:li. The function shrink, which was necessary only for the Atari version,
is now explained as being obsolete in the help file. It will issue an
error message, when called with nonreal arguments.
:li. eof() is corrected to have no arguments and getchar() is explained
correctly in the help file.
:li. Charactercodes from 32 to 255 are now recognized on input.
:li. Commands help and type now show, if there is a builtin function
with the same name.
:li. Key assignment changed a bit for tracing. Explaining the help key
and the function keys in the help file.
:li. Tabulator is now expanded in the text window.
:li. Included vertical axis labelling. Vertical print works now.
:li. Removed a bug in the keyboard handling (Dead characters, 
ascents).
:li. Included internal text editing.
:li. The wait function works again.
:li. Catched possible illegal values for setplot, plot and plot ticks.
:li. Added vertical upward text. Make it default for vertical xplot.
:li. Corrected spelling error in name of vctext.
:li. Added hundreds of better error descriptions in the source.
:li. Explained jacobi and errorlevel in the help file.
:li. You can now save your window positions and sizes.
:li. EULER.INF is now no longer included, since there are HLP file 
browsers in the public domain.
:li. Function eigen1 documented and corrected.
:li. System lock on long output and other occasions removed.
:li. Error with multiple returns of functions without arguments called
without brackets removed.
:li. Problem with files ending in last line removed.
:li. Removed some crashes, if graphics window is resized during draw actions.
:li. Gave names to print jobs.
:li. Streamlined the PM interface. Outputs like print do have an own thread
now. 
:li. Blocked input is now indicated by a busy pointer.
:li. Crashes due to noreentrant code have been removed by blocking the 
computation.
:li. Option, not to use a bitmap, is no longer available. It simply caused
to many problems.
:li. The main window has a text cursor.
:li. It is now possible to mark text in the last line.
:li. Added the functions xgrid1, ygrid1 to allow logarithmic plots.
:li. Did some other more changes to the interface using more threads and
introduced semaphores for security. Still learning about PM.
:li. Removed the typo in wait() in UTIL.
:li. Removed clipboard hang after pasting non-text.
:li. Removed another bug, which caused EULER to crash after stack overflow.
:li. Workaround for the drivers bug in Warp, which causes lines outside the
EULER windows.
:li. Clear-Graphics command removed from clipboard and file metafile.
:li. Metafile is now cleared by a white box.
:li. Text is clipped to the screen.
:li. Wrote a simplex algorithm for EULER.
:li. Introduced black and white option.
:li. Take care, if the normal background is not white.
:li. Improved stepping in for loops, even for small steps.
:li. Removed a bug in assignments with for index.
:li. It is now possible to switch math errors on. This generates an error for
log(-1) and such.
:li. Limit function depth to 400. Gave Euler a 256 KB stack. It may still crash,
if recursion is called in formula. But this is the best I could do in
view of the different OS versions.
:li. Removed a small bug on nonstandard color background of bitmaps.
:li. Added interval arithmetic.
:li. You can now use '...' for strings and compare them with ==, <, ...
:li. Introduced ...elseif...
:li. Increased the number of possible parameters to 20.
:li. Made STORE/RESTORE work through several sessions of EULER.
:li. Changed the look of complex and interval output.
:li. You can now enter [2,1&colon.4] for matrix input.
:li. Had to take back the '...' notation for strings. It was
confusing the function parser. Introduced ''....'' for easy
input of string cntaining ".
:li. Mouse clicks are no longer reached through to the windows.
They just top them.
:li. (3.30) Introduced version numbers in this list.
:li. Exact scalar product written.
:li. Removed a bug in interval times real matrix multiplication.
:li. Allows two more digits than the DBL_DIGITS indicates.
:li. (3.31) Work around for buggy printer drivers (font alignment).
:li. Switched off use of marker fonts. This is a work around for
buggy printer drivers.
:li. (3.32) Some improvements in the sample sessions.
:li. INTERVAL.E included.
:li. ~x~ works for intervals x.
:li. middle(x), left(x), right(x) and diameter(x) works for non-interval
:li. expand written.
:li. (3.33) A\b will no longer report "determinant 0", unless it is 
numically 0 (epsilon is no longer used).
:li. Made s{...} work for interval matrix s.
:li. Corrected prod for intervals.
:li. Made cumprod and cumsum work for intervals.
:li. (3.34) _ and | now work for interval matrices.
:li. Introduced goodformat, expformat, fixedformat and iformat.
:li. Corrected expand for real and very big arguments.
:li. (3.35) Wrote putchar(v), putword, putlongword, getchar, getword,
getlongword and getstring.
:li. Changed file name buffer$$ to aaaa$$$$ in text edit.
:li. Explained some of the included *.e file in the documentation.
:li. Wrote comment, which toggels comment switch on and off.
:li. (3.36) Fixed an error in complex polyval, which originates
from two or three versions ago.
:li. Switched fft and ifft, to make the behavior conformal with MatLab. 
Sorry, if you have to do major changes.
:li. (3.37) Changed the ilgs solver, so that it finds an inclusion more 
often.
:li. Changed the computation session priority to idletime, which works 
smoother and allows easier interrupt.
:li. Changed clipboard marking to double clicks.
:li. Made abs work for interval variables.
:li. (3.99) Beta version of 3.40. New: Notebook features.
:li. Selecting is now done with the right mouse button. The left mouse 
button is now used as a text mark.
:li. Command recall is now done with SHIFT-UP and SHIFT-DOWN in the 
notebook version.
:li. (4.00) _ and | now work for interval and real mixes.
:li. return # is now fixed from within loops.
:li. Changed the function iterate, and introduced niterate.
:li. Functions steffenson and nsteffenson are now in UTIL.E.
:li. (4.01) Improved ilgs a bit (fixed an error in a beta version).
:li. newton and newton2 are now in UTIL.
:li. Made iterate work for intervals.
:li. Made niterate and nsteffenson work for vectors.
:li. Inserting a function in a notebook does no longer eat up
commands.
:li. (4.03) Removed a bug in notbook loading, when the first command
had no text.
:li. Removed a bug in ipolyval, when the argument is a vector.
:li. Added xpolyval, xlgs and xlusolve in UTIL.
:li. Defined isfunction, which allowed to rewrite bisect etc. so that 
expression can be used.
:li. Added useglobal.
:li. Added root to UTIL.
:li. (4.04) Still fighting with the priority settings. Now you can leave 
EULER computations on regular priority. I compromized by peeking the 
message queue every now and then.
:li. (4.05) Changed some internal things. I have a DOS version now, which
is VERY restricted, but runs.
:li. Some utilities are moved from UTIL.E to other files. These files are
loaded from EULER.CFG.
:li. "dir" and "cd" are now commands and can be used without brackets.
:li. "changedir" replaces the function "cd" now.
:li. The command "notebook" can load notebooks, the command prompt can
be turned on and off.
:li. == and <> works for complex numbers and intervals now.
:li. You can compare intervals with < and > now.
:li. The new function "evaluate" works like "interpret", but aborts on
errors.
:li. Removed some bugs in the PM interface in connection with 
notebooks (e.g. crashes on loading).
:li. Made ~= compare the the relative error (instead of the absolute 
error), if the values are largern than epsilon.
:li. You can now specify the epsilon as "eps=..." in "bisect" etc.
:li. Wrote "isvar" to test for the existence of a variable.
:li. "localepsilon" sets the epsilon locally for a function.
:li. "divdif" may be used instaed of "interp", and "divdifval"
instead of "interpval".
:li. (4.06) Improved "kernel" etc. by normalizing the matrix first.
:li. Wrote "norm".
:li. Wrote "xeigenvalue".
:li. (4.07) Corrected a bug in args() parameter, that allowed
assignment to extra parameters.
:li. ;... did not work for the "broyden" function.
:li. Empty intersections (and other errors) were reported more than
once with vector input.
:li. eps=... was fatal for the Newton method and large eps, because
the linear system solver took the same eps.
:li. Improved the interval Newton methods "inewton" and "inewton2".
Both return a validation flag.
:li. (4.08) removed a bug in det from version 4.07.
:li. (4.09) changed a strange behavior of multiple returns
when the result is used as an operand.
:li. xlgs now uses lusolve, as it should. This is faster.
:li. removed solvelgs from util.e, since it is not needed.
:li. Changed the behavior of oerators. Now, operators between
1xn and mx1 matrices work and produce an mxn result (and others).
This removes the need to use "field".
:li. Had to extend "solid", "solidhue" and "wire".
:li. Wrote "resize", which makes it possible to write functions
of many parameters, which work like the internal operators.
:li. New command "listvar".
:li. Improved "remez".
:li. (4.10) Removed the save bug from the internal function editor.
:li. "fft" and "iff" were not correctly catching a stack overflow.
:li. (4.11) Finally removed the bug in the topline of the notebooks.
:li. (4.12) Made the notepad keys work.
:li. (4.13) Some minor improvements in code.
:li. Changed the code for alignment on UNIX systems.
:li. (4.14) Added the keepsquare function.
:li. Bitmaps may now be saved and copied to clipboard in user
chosen sizes.
:li. (4.15) Some changes in the included *.e files.
:li. Alignment code for the UNIX version changed (but still not works
on DEC).
:li. (4.16) Corrected saving of 3D-colors.
:eul.


:euserdoc.
